function dp_plot_update(plot_nr);

main_data = get(gcf,'UserData');

if (plot_nr == 1)
    tag_axes = 'demo_predictor_axes_top';
    set(gcf,'CurrentAxes',findobj('Tag',tag_axes));
    plot_method   = main_data.axes_top.plot_method;
    plot_handle_1 = main_data.axes_top.plot_handle_1;
    plot_handle_2 = main_data.axes_top.plot_handle_2;
    index         = main_data.axes_top.index;
else
    tag_axes = 'demo_predictor_axes_bottom';
    set(gcf,'CurrentAxes',findobj('Tag',tag_axes)); 
    plot_method   = main_data.axes_bottom.plot_method;
    plot_handle_1 = main_data.axes_bottom.plot_handle_1;
    plot_handle_2 = main_data.axes_bottom.plot_handle_2;            
    index         = main_data.axes_bottom.index;
end;

switch plot_method
    
    case 'pred_err'
        t = main_data.predictor.k_frame * main_data.predictor.frameshift;
        sig_old = get(plot_handle_1,'YData');
        sig_old = sig_old(2);
        if (main_data.predictor.k_dir == 1)
            for k = 0: main_data.predictor.frameshift-1
                set(plot_handle_1,'XData',[(t-1+k)/main_data.f_s (t+k)/main_data.f_s],'YData',[sig_old main_data.predictor.error_vec(k+1)]);         
            end;        
        else
            for k = main_data.predictor.frameshift-1:-1:0
                set(plot_handle_1,'XData',[(t+k)/main_data.f_s (t-1+k)/main_data.f_s],'YData',[sig_old main_data.predictor.error_vec(k+1)]);         
            end;               
        end;
                 
    case 'imp_res'        
        for k = 1:length(main_data.predictor.h)
           set(plot_handle_1(k),'YData',[0 0 main_data.predictor.h(k) main_data.predictor.h(k)]);
        end;
        
    case 'tf_ana'
        t = main_data.predictor.k_frame * main_data.predictor.frameshift / main_data.f_s;
        set(main_data.axes_bottom.plot_handle_1,'XData',[t t]);  
        
    case 't_ana'       
        t = main_data.predictor.k_frame * main_data.predictor.frameshift / main_data.f_s;
        set(main_data.axes_bottom.plot_handle_1,'XData',[t t]);        
        
    case 'spec_env'                       
        spec_sig = 20*log10(abs(fft(main_data.predictor.x_ana.*main_data.predictor.h_ana,main_data.predictor.n_fft)+eps));
        spec_sig = spec_sig(1:main_data.predictor.n_fft/2+1);
        spec_inv_pred = freqz(main_data.predictor.gain,main_data.predictor.h,main_data.predictor.n_fft,'whole');
        spec_inv_pred = 20*log10(abs(spec_inv_pred(1:main_data.predictor.n_fft/2+1))+eps);
        set(plot_handle_1,'YData',spec_sig);
        set(plot_handle_2,'YData',spec_inv_pred);

    case 'imp_res'                       
        spec_sig = 20*log10(abs(fft(main_data.predictor.x_ana.*main_data.predictor.h_ana,main_data.predictor.n_fft)+eps));
        spec_sig = spec_sig(1:main_data.predictor.n_fft/2+1);
        spec_inv_pred = freqz(main_data.predictor.gain,main_data.predictor.h,main_data.predictor.n_fft,'whole');
        spec_inv_pred = 20*log10(abs(spec_inv_pred(1:main_data.predictor.n_fft/2+1))+eps);
        set(plot_handle_1,'YData',spec_sig);
        set(plot_handle_2,'YData',spec_inv_pred);        
        
end;

if (plot_nr == 1)
    main_data.axes_top.index = index;
else
    main_data.axes_bottom.index = index;     
end;

set(gca,'Tag',tag_axes);
set(gcf,'UserData',main_data);

drawnow;

