function dp_update_predictor;

main_data = get(gcf,'UserData');

%**************************************************************************
% Update frame counter
%**************************************************************************

if (main_data.predictor.k_dir == 1)
    main_data.predictor.k_frame = main_data.predictor.k_frame + 1;
    if (main_data.predictor.k_frame * main_data.predictor.frameshift > ...
            length(main_data.signals.x) - ceil(main_data.predictor.n_ana/2))
        main_data.predictor.k_frame = ceil(main_data.predictor.n_ana / ...
                                      (2 * main_data.predictor.frameshift));
    end;
else
    main_data.predictor.k_frame = main_data.predictor.k_frame - 1;
    if (main_data.predictor.k_frame * main_data.predictor.frameshift < ...
            ceil(main_data.predictor.n_ana/2))
       main_data.predictor.k_frame =  floor((length(main_data.signals.x) - ...
            ceil(main_data.predictor.n_ana/2)) / main_data.predictor.frameshift);
    end;
end;

%**************************************************************************
% Update input vectors
%**************************************************************************

k_start = main_data.predictor.k_frame * main_data.predictor.frameshift ...
          - floor(main_data.predictor.n_ana/2)+1;
k_end   = main_data.predictor.k_frame * main_data.predictor.frameshift ...
          + floor(main_data.predictor.n_ana/2);
          
main_data.predictor.x_ana = main_data.signals.x(k_start:k_end);



[coeff,pow]              = lpc(main_data.predictor.x_ana.* ...
                           main_data.predictor.h_ana,main_data.predictor.length);
main_data.predictor.h    = real(coeff);
main_data.predictor.gain = sqrt(real(pow)*main_data.predictor.n_ana);
if (main_data.predictor.k_dir == 1)
    for k = 1:main_data.predictor.frameshift
        main_data.predictor.x_p(2:end)   = main_data.predictor.x_p(1:end-1);
        main_data.predictor.x_p(1)       = main_data.signals.x(main_data.predictor.k_frame * main_data.predictor.frameshift + k - 1);
        main_data.predictor.error_vec(k) = main_data.predictor.h * main_data.predictor.x_p;
    end;
else
    for k = main_data.predictor.frameshift:-1:1
        main_data.predictor.x_p(1:end-1) = main_data.predictor.x_p(2:end);
        main_data.predictor.x_p(end)     = main_data.signals.x(main_data.predictor.k_frame * main_data.predictor.frameshift + k - 1);
        main_data.predictor.error_vec(k) = main_data.predictor.h * main_data.predictor.x_p;
    end;
end;

%**************************************************************************
% Compute error signal
%**************************************************************************

set(gcf,'UserData',main_data);